/// Nombre de facettes sur le pourtour des surfaces arrondies
$fn =30;

// Dessine un anneau d'une couleur donnée
// et défini par sa hauteur et ses deux diamètres
module anneau(couleur, hauteur, diamInt, diamExt) {
  color(couleur, 1.0) {
    difference() {
      cylinder(h = hauteur, d = diamExt, center=true); 
      translate([0, 0, -hauteur/2]) {
        cylinder(h = hauteur * 4, d = diamInt, center=true); 
      }
    }
  }  
}

// dessine les 5 anneaux colorés
module anneauxOlympiques(hauteur, diamInt, diamExt) {
  // variables de travail permettant de décaler les anneaux
  // proportionnellement au dialExt
  decalX = 1.1;
  decalY = decalX/2.0;
  // tableau des couleurs des anneaux
  colors = ["blue", "black", "red", "yellow", "green"];
  
  // 3 anneaux décalés sur les x
  for(x = [0, 1, 2]) {
    // chaque anneau est décalé avant d'être dessiné
    translate([x * diamExt * decalX, 0, 0]) {
      anneau(colors[x], hauteur, diamInt, diamExt);
    }
  }
  // 2 anneaux décalés sur les y  
  translate([0, -diamExt * decalY, 0]) {
    // décalé sur les x 
    translate([diamExt * decalX/2.0, 0, 0]) {
      anneau(colors[3], hauteur, diamInt, diamExt);
    }
    translate([diamExt * (decalX * 1.5), 0, 0]) {
      anneau(colors[4], hauteur, diamInt, diamExt);
    }
  }
}

// lancement du dessin des anneaux
 anneauxOlympiques(10., 260., 300.);

// Dessine un anneau d'une couleur donnée
// et défini par sa hauteur et ses deux diamètres
module anneauNonColore(hauteur, diamInt, diamExt) {
  difference() {
    cylinder(h=hauteur, d=diamExt, center=true); 
    translate([0, 0, -hauteur/2]) {
 #     cylinder(h = hauteur * 4, d = diamInt, center=true); 
    }
  }  
}
// test un seul anneau non coloré
//anneauNonColore(10., 260., 300.);