// un "carré" évidé
module carre(taille, ht, lg) {
  difference() {
    cube([taille, taille, ht]);
    translate([lg / 2., lg / 2., -ht]) {
      cube([taille - lg, taille - lg, ht * 3]);
    }
  }
}

// Eventail de carrés itératif
// rotationZ sert à contrôler la rotation autour de z
module tournerCarresIteratif(taille, ht, lg, delta, rotationZ) {
  for (angleX = [0:delta:180]) {
    rotate([angleX, 0, rotationZ * angleX / 3.0]) {
      carre(taille, ht, lg);
    }
  }
}

// Eventail de carrés récursif 
// arrêt de la récursion quand angle >= 180
module tournerCarresRec(taille, ht, lg, angle, delta) {
  // pour arrêter la récursion
  if (angle <= 180) {
    rotate([delta, 0, 0]) {
      carre(taille, ht, lg);
      tournerCarresRec(taille, ht, lg, angle + delta, delta);
    }
  }
}

// appel de la méthode récursive avec ajout de l'argument
// donnant sa valeur initiale au paramètre angle <- 0
module tournerCarresRecursif(taille, ht, lg, delta) {
  tournerCarresRec(taille, ht, lg, 0, delta);
}


// décommenter seulement une des méthodes à tester

// 5° argument : 
// rotationZ <- 0 pour rotation autour de x, 
// rotationZ <- 1 pour rotation autour de x et de z
tournerCarresIteratif(20, 1, 2, 15, 0);

// test de la méthode récursive
//tournerCarresRecursif(20, 2, 5, 30);

// test d'une seul carré évidé
//carre(20, 1, 3);