// utilisation d'une librairie gérant les textes
use<Write.scad>
// taille minimale d'une facette
//$fs = 1;
$fn = 100;

module texte(ray1, ray2, ht) {
    write("Macintosh classic", h=15, t=5, font="Letters.dxf", space = 1); 
}

module corpsEtDisquette(tX, tY, tZ) {
    difference() {
        // corps
        cube([tX, tY, tZ*4./5.]); 
        translate([tX/10., tY*2./3., tZ/10.]) {
            // lecteur de disquette
           cube(size=[tX/2.5, tY, tZ/30.]);
        }
    }
}
 
module macintosh(tX, tY, tZ) {
    difference() {
        union() {
            // socle
            cube(size = [tX, tY * 4./5., tZ/5.], center=false); 
            // haut
            translate([0, 0, tZ/5. - tZ/20.]) {
                difference() {
                    corpsEtDisquette(tX, tY, tZ);
                    //ecran
                   translate([tX * 1./8., tY * 19./20., tZ * 1./3.]) {
                      cube([tX * 3./4., tY * 3., tZ * 2./5.]);
                    }
                }
            }
           // partie texte 
            translate([tX*  9./10., tY - tY/20., tZ/5.]) {
                rotate([-90, 0, 0]) {
                    rotate([0, 0, 180]) {
                        scale([0.12, 0.12, 0.5]) {
                            texte(15, 5);
                        }
                    }
                }
            }
        }
        translate([tX/2., tX/2., tZ/10.]) {
            cylinder(d = tX * 0.8, h = tZ, center=false);
        }
    }
}

// toutes les dimensions sont relatives à ces 3 là
macintosh(30., 40., 50.);


 